#include <stdio.h>

main(argc,argv)
int argc;
char **argv;
{
	FILE *output_file,*spice_file,*names_file,*model_file;
	FILE *temp_file,*data_file,*input_file, *analysis_file;
	FILE *fopen(),*fclose();
	char unit[5],ignore[25],name[25],copy[25],copy1[25],nodename[25];
	char delay_string[10],length[10],width[10],voltage_type[10],type[10];
	char dependency[20];
	int i,j,k,l,gate,node_num,switching_node;
	double nload, pload, cload;
	double delay,moslen,moswid;
	double translate();
	double atof();
	int    atoi();
	struct output{
		char name[20];
		int node_num;
		} out_list[10];

	struct input{
		char name[20];
		int  node_num;
		double  n_area;
		double  p_area;
		} input_list[10];


	for (i=0;i < 10; i++){
		strcpy(input_list[i].name,"");
		input_list[i].node_num = 0;
		strcpy(out_list[i].name,"");
		out_list[i].node_num = 0;
		input_list[i].n_area = 0.0;
		input_list[i].p_area = 0.0;
	}
	if ( argc <= 1 ) {
		printf("No input specified");
		exit(-1);
         }
	else {
		strcpy(copy,argv[1]);
		names_file = fopen("comments_file","r");
		/* The spice network is to be is file spice_net */
		spice_file = fopen("spice_net","r");
		if( strcmp(argv[3],"make") == 0){
				strcpy(copy1,copy);
				output_file = fopen(strcat(copy,".terminals"),"w");
				strcat(copy1,".input.");
				strcat(copy1,argv[2]);
				input_file = fopen(copy1,"r");
				fscanf(input_file,"%*c%s \n",dependency);
				model_file = fopen("out_model_file","w");
				analysis_file = fopen("analysis_file","w");

		}

		/* Form the structure containing node names and node numbers
		for the input and the output terminals */

		i=0;
		k=0;
		while ( fscanf(names_file,"%*c %s %d \n", nodename,&node_num) != EOF){
			switch (nodename[0]) {
			case 'O' :
				strcpy(out_list[k].name,nodename);
				out_list[k].node_num = node_num;
				k = k+1;
				 break;
			case 'G' :
				 break;
			case 'V' :
				 break;
			case 'P' :
				 break;
			case 'N' :
				 break;
			case 'n' :
				 break;
			case 'p' :
				 break;
			default :
				if((nodename[1] < '0') || (nodename[1] > '9')){
					strcpy(input_list[i].name,nodename);
					input_list[i].node_num = node_num;
					i = i+1;
				}
				break;
			}
		}

		/* Find the Xstrs that have their gates connected to a input
		terminal and compute the area. 					*/
		i = 0;
		while ( fscanf(spice_file,"%*s%*d%d%*d%*d%s%*c%*c%*c%[0123456789.UKMNE-]%*c%*c%*c%[0123456789=.UKMNE-] \n", &gate,type,length,width) != EOF){
			for (j =0; strcmp(input_list[j].name,"") != 0; j++){
				if ( gate == input_list[j].node_num){
					moslen = translate(length);
					moswid = translate(width);
					if ( strcmp(type,"nmos") == 0){
						input_list[j].n_area = input_list[j].n_area + (moslen *moswid);
					}
					else if (strcmp(type,"pmos") == 0){
						input_list[j].p_area =input_list[j].p_area + (moslen *moswid);
					}
				}
			} 
		}
		if ( strcmp( argv[3],"make") == 0 ){
		/* from the input list find a node which has a PULSE
		or a PWL voltage applied to it */

			while ( fscanf(input_file,"%*s%d%*d%s%*[0123456789.()VvoltNnSseCc-]\n", &node_num ,voltage_type) != EOF){
				if( (strcmp(voltage_type,"PWL") == 0 ) || (strcmp(voltage_type,"PULSE") == 0 ) ){
					switching_node = node_num;
					break;
				}
			}

		 /* print the information into a file */

			 for (j = 0; strcmp(input_list[j].name,"") != 0 ; j++){
		        fprintf(output_file,"%s  %e %e \n",input_list[j].name,input_list[j].n_area,input_list[j].p_area);
			 }
			 fclose(output_file);
	
			 /* Build up the output model based on the command line numbers */
	
			 nload = ( atoi(argv[4]) ) * ( atof(argv[5]) ) * 1.0e-6;
			 pload = ( atoi(argv[6]) ) * ( atof(argv[7]) ) * 1.0e-6;
			 cload = ( atoi(argv[8]) ) * ( atof(argv[9]) ) * 1.0e-15;
	
			 fprintf(model_file,"\n");
			 for ( i =0; strcmp(out_list[i].name ,"") != 0 ; i++){
				k = 100 +i;
			 	fprintf(model_file,"C%s %d 0 %e \n",out_list[i].name,  out_list[i].node_num , cload );
			 	fprintf(model_file,"MP%s 1 %d %d 3 pmos  L=%sU W=%e \n",out_list[i].name,out_list[i].node_num ,k, argv[10], pload );
			 	fprintf(model_file,"MN%s 2 %d %d 4 nmos  L=%sU W=%e \n",out_list[i].name,out_list[i].node_num ,k, argv[10], nload );
			 }
			 fprintf(model_file,"\n");

	
			 fprintf(analysis_file,".PRINT TRAN V(%d) ",switching_node);
			 for( i=0 ; strcmp(out_list[i].name,"") != 0 ; i++){
			 	fprintf(analysis_file,"V(%d) ",out_list[i].node_num);
			 }
			 fprintf(analysis_file,"\n");
			 fclose(analysis_file);
			 fclose(model_file);
			if ( strcmp(dependency,"SYMMETRIC") == 0)
				exit(1);
			else if ( strcmp(dependency,"ANTI_SYMMETRIC") == 0)
				exit(2);
			else if ( strcmp(dependency,"BOTH") == 0)
				exit(3);
			else exit(0);
		}
		else if ( strcmp(argv[3],"data") == 0){
			strcpy(copy1,argv[1]);
	 		strcat(copy1,".result.");
	 		strcat(copy1,argv[2]);
			data_file = fopen(copy1,"w");
			strcpy(copy1,argv[1]);
	 		strcat(copy1,".temp.");
	 		strcat(copy1,argv[2]);
			temp_file = fopen(copy1,"r"); 

			/* Read the temp file and write the data into
			the data_file   				*/

			fprintf(data_file,"NLOAD        PLOAD         CLOAD  ");
			for ( i=0; strcmp(out_list[i].name,"") != 0 ; i++){
				fprintf(data_file,"%13s",out_list[i].name);
			}
			fprintf( data_file,"\n");
			for ( i=1; i <  atoi(argv[4]) ; i++){
				nload = i * atof(argv[5]) * 1.0e-6 * atof(argv[10]) * 1.0e-6 ;
				for ( j=1; j <  atoi(argv[6]) ; j++){
					pload = j * atof(argv[7]) * 1.0e-6 * atof(argv[10]) * 1.0e-6 ;
					for ( k=1; k <  atoi(argv[8]) ; k++){
						cload = k * atof(argv[9]) * 1.0e-15 ;
						fprintf(data_file,"%e %e %e",nload,pload,cload);
						for(l = 0; strcmp(out_list[l].name,"") != 0; l++){
							fscanf(temp_file,"%s%s",delay_string,unit);
							strcat(delay_string,unit);
							delay = translate(delay_string);
							fprintf(data_file," %e ",delay);
						}
						fprintf( data_file,"\n");
					}
				}
			}
		}
	}
}

double translate(string)
char *string;
{
        double atof();

	int i;
	double value;
	char temp[20], new_char;

	strcpy(temp,"");
	value = 0;

	for ( new_char = *string, i=0 ; new_char != '\0' ; i++ ,new_char = *++string ){
		switch (new_char) {
		case 'u' :
		case 'U' : temp[i++] = 'e';
			   temp[i++] = '-';
			   temp[i]   = '6';
				break;
		case 'n' :
		case 'N' : temp[i++] = 'e';
			   temp[i++] = '-';
			   temp[i]   = '9';
				break;
		case 'k' :
		case 'K' : temp[i++] = 'e';
			   temp[i]   = '3';
				break;
		case 'p' :
		case 'P' : temp[i++] = 'e';
			   temp[i++] = '-';
			   temp[i++] = '1';
			   temp[i]   = '2';
				break;
		case 'm' :
		case 'M' : temp[i++] = 'e';
			   temp[i]   = '6';
				break;
		default  : temp[i] = new_char;
				break;
		}
	}
	temp[i] = '\0';
	value =  atof(temp) ;
	return(value);
}
