#include <stdio.h>
#define MAXCHARS 256	/* maximum chars per line */

/* VIAS is a macro to testing via tiles for (size+1) modulo 5
 * CONT is a macro for testong contacts tiles for modulo 4
 */
#define VIAS(LLX,LLY,URX,URY)\
		(URX-LLX+1) % 5 == 0 ? ((URY-LLY+1) % 5 == 0 ? 0 : 1) : 1
#define CONT(LLX,LLY,URX,URY)\
		(URX-LLX) % 4 == 0 ? ((URY-LLY) % 4 == 0 ? 0 : 1) : 1
#define NUM_CONTACTS 9
#define NUM_VIAS 4
int contact = 0;
int llx,lly,urx,ury;
FILE *fp2; 
char *X;

main(argc,argv)
int argc;
char *argv[];
{
	char line[MAXCHARS];
	char rect[MAXCHARS];
	FILE *fp; 

	X = "X";
	if (argc!=3)
		printf("Usage: drc file.mag file.src\n");
	else
	if (!((fp2 = fopen(argv[2],"w"))==NULL))
	{
	if ((fp = fopen(argv[1],"r"))!=NULL)
		while ((fgets(line,MAXCHARS-1,fp))!=NULL)
		{
		if ( line[0] == '<')
			check_it(line);
		else if ( line[0] == 'u')
			contact = 0;
		else if (contact == 99)
			{
			sscanf(line,"%s %d %d %d %d",rect,&llx,&lly,&urx,&ury);
			if (CONT(llx,lly,urx,ury)!=0)
	fprintf(fp2,"box %d %d %d %d;feedback add \" \
Contact tiles must be modulo 4.\"\n",llx,lly,urx,ury);
			}
		else if (contact == -99)
			{
			sscanf(line,"%s %d %d %d %d",rect,&llx,&lly,&urx,&ury);
			if (VIAS(llx,lly,urx,ury)!=0)
	fprintf(fp2,"box %d %d %d %d;feedback add \" \
Via tiles must be (width+1) modulo 5.\"\n",llx,lly,urx,ury);
			}
		}
	}						
	else
		printf("Could not open file %S for writing.\n",argv[2]);
}
check_it(line)
char *line;
{
	int c;
static	char *contacts[NUM_CONTACTS] = {
					"<< polycut >>\n",
					"<< ndiffcut >>\n",
					"<< pdiffcut >>\n",
					"<< pwellplug >>\n",
					"<< nwellplug >>\n",
					"<< genricplug >>\n",
					"<< pic >>\n",
					"<< pdoc >>\n",
					"<< ndoc >>\n"
					};
static	char *vias[NUM_VIAS] = {
				"<< via >>\n",
				"<< m2cut >>\n",
				"<< iv >>\n",
				"<< ov >>\n"
				};

	contact = 0;
	for (c=0;c<NUM_CONTACTS;++c)
	if (strcmp(line,contacts[c])==0)
		contact = 99;
	for (c=0;c<NUM_VIAS;++c)
	if (strcmp(line,vias[c])==0)
		contact = -99;
}
